/************************************************/
/*xZT̃f[^`cϊĉt	*/
/*\vOłB			*/
/************************************************/
/* CN[h					*/
/************************************************/

#include "3664f.h"
#include "machine.h"


/************************************************/
/* vg^Cv錾				*/
/************************************************/

extern void reset( void );

void main( void );
void wait( int msec );
void lcd_init( void );
void lcd_cls( void );
void lcd_ir_write( unsigned char data );
void lcd_dr_write( unsigned char data );
void lcd_clock( unsigned char data );
void lcd_print( char *data );
void lcd_locate( unsigned char x, unsigned char y );

#define LCD_CTLPORT_DR	PDR1
#define LCD_CTLPORT_CR	PCR1
#define LCD_E		0x01						/* bit0 */
#define LCD_RW		0x02						/* bit1 */
#define LCD_RS		0x04						/* bit2 */
#define LCD_DATPORT_DR	PDR5
#define LCD_DATPORT_CR	PCR5

const unsigned char disp_table[] = "0123456789ABCDEF";

/************************************************/
/* 					*/
/************************************************/

void reset( void )
#pragma asm
	mov.l		#H'FF80,ER7	;X^bN|C^
#pragma endasm
{
	set_imask_ccr( 0 );
	_INITSCT();
	main();
	sleep();
}

/*************************************************
 C
*************************************************/
void main( void )
{
	unsigned long tmp;

	lcd_init();				/* LCD */

	while(1){
		*ADCSR = 0x20;			/* ϊX^[g */
		while( ( *ADCSR & 0x80 ) == 0 ){
		}
		*ADCSR = *ADCSR & ~0x80;	/* ϊItONA */

		tmp = 0 + ( 309 - ( unsigned long )( ( *ADDRA & 0xffc0 ) >> 6 ) ) * 100 / 169;

		lcd_locate( 0, 0 );
		lcd_print("temp=");
		lcd_dr_write( disp_table[ ( ( tmp / 10 ) & 0xf ) ] );
		lcd_dr_write( disp_table[ ( ( tmp % 10 ) & 0xf ) ] );

	}
}

/*************************************************
 t\
*************************************************/
void lcd_cls( void )
{
	lcd_ir_write( 0x01 );
	wait( 2 );
}

void lcd_locate( unsigned char x, unsigned char y )
{
	unsigned char i;
	i = y * 0x40 + x;
	i = i | 0x80;
	lcd_ir_write( i );
}

void lcd_print( char *data )
{
	while( *data != '\0' ){
		lcd_dr_write( *data );
		data++;
	}
}

void lcd_init( void )
{
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_E & ~LCD_RW & ~LCD_RS;
	*LCD_DATPORT_DR = 0x00;
	*LCD_CTLPORT_CR = *LCD_CTLPORT_DR | LCD_E | LCD_RW | LCD_RS;
	*LCD_DATPORT_CR = 0xff;

	wait( 20 );
	lcd_clock( 3 );							/* function set */
	wait( 5 );
	lcd_clock( 3 );							/* function set */
	lcd_clock( 3 );							/* function set */
	lcd_clock( 2 );							/* function set */

	lcd_ir_write( 0x28 );						/* function set */
	lcd_ir_write( 0x08 );						/* on/off control */
	lcd_cls();
	lcd_ir_write( 0x06 );						/* entry mode set */
	lcd_ir_write( 0x0e );						/* on/off control */
}

void lcd_ir_write( unsigned char data )
{
	unsigned char i;

	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RS;
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RW;		/* write */

	i = ( data & 0xf0 ) >> 4;
	lcd_clock( i );

	i = data & 0xf;
	lcd_clock( i );
}

void lcd_dr_write( unsigned char data )
{
	unsigned char i;

	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR | LCD_RS;
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_RW;		/* write */

	i = ( data & 0xf0 ) >> 4;
	lcd_clock( i );

	i = data & 0xf;
	lcd_clock( i );
}

void lcd_clock( unsigned char data )
{
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR | LCD_E;
	*LCD_DATPORT_DR = ( *LCD_DATPORT_DR & 0xf0 ) | ( data & 0x0f );
	wait( 1 );
	*LCD_CTLPORT_DR = *LCD_CTLPORT_DR & ~LCD_E;
	wait( 1 );
	*LCD_DATPORT_DR = ( *LCD_CTLPORT_DR & 0xf0 );
}

/*************************************************
 ^C}[
*************************************************/
void wait( int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}


